#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "dol.h"
#include "byteswap.h"

int main (int argc, char * argv[] ) {
	int dol_fd;
	int i;
	int dol_hdr_serad;
	dol_hdr_t dol_hdr;
	
	printf("Readdol v. 0.01 by NiTRo THe DeMoN\n\n");
	
	if (argc != 2) {
		printf("Usage: %s [filename]\n", argv[0]);
		exit(1);
	}
	
	dol_fd = open(argv[1], O_RDONLY);
	if (dol_fd <= 0) {
		printf("File not found: %s\n", argv[1]);
		exit(1);
	}

	dol_hdr_serad = read(dol_fd, &dol_hdr, sizeof(dol_hdr_t));
	printf("Filename: %s\n", argv[1]);
	
	printf("\n.text\n");
	for (i = 0; i < 7; i++){
		printf(" section[%d]\n",i);
		if ( dol_hdr.text_offs[i] && dol_hdr.text_addr[i] && dol_hdr.text_size[i]) {
			/* All values are big endian, so need to be swapped on x86 machines. */
			printf("  file offset = 0x%0.8x\n",swap_uint32(dol_hdr.text_offs[i]));
			printf("  mem address = 0x%0.8x\n",swap_uint32(dol_hdr.text_addr[i]));
			printf("  size = %u bytes\n",swap_uint32(dol_hdr.text_size[i]));
		}else{
			printf("  unused\n");
		}
	}
	printf("\n.data\n");
	for (i = 0; i < 11; i++){
		printf(" section[%2d]\n",i);
		if ( dol_hdr.data_offs[i] && dol_hdr.data_addr[i] && dol_hdr.data_size[i]) {
			printf("  file offset = 0x%0.8x\n",swap_uint32(dol_hdr.data_offs[i]));
			printf("  mem address = 0x%0.8x\n",swap_uint32(dol_hdr.data_addr[i]));
			printf("  size = %u bytes\n",swap_uint32(dol_hdr.data_size[i]));
		}else{
			printf("  unused\n");
		}
	}
	printf("\n.bss\n");
	printf(" mem address = 0x%0.8x\n",swap_uint32(dol_hdr.bss_addr));
	printf(" size = %u bytes\n",swap_uint32(dol_hdr.bss_size));
	printf("\nentry point\n");
	printf(" mem address = 0x%0.8x\n",swap_uint32(dol_hdr.entry_point));
	printf("\npadding\n");
	for (i = 0; i < 7; i++){
		if ( i % 4 == 0) printf (" ");
		printf("%0.8x",swap_uint32(dol_hdr.padding[i]));
		if ( i % 4 == 3) {
			printf ("\n");
		} else {
			printf (" ");
		}
	}
	close(dol_fd);
	exit(0);
}
